<?php
/**
 * Plugin Adm_redacteurs
 * Version  : 5.5.4 (2009/07/07)
 * Compatibility : Guppy v4.6.6+
 * Author   : jrme CROUX (djchouix)
 * Web site : http://lebrikabrak.info/
 * E-mail   : lebrikabrak@free.fr
 * Licence  : GNU Lesser General Public License
 *
 * Ce fichier est bas sur le fichier suivant:
 * Fork MinieditorTextarea ralis par Djchouix    
 * CeCILL Copyright (C) 2004-2006 by Laurent Duveau
 * Made by Laurent Duveau, Nicolas Alves, Albert Aymard,
 * Jean-Michel Misrachi, Isabelle Marchina and Team
 * Web site = http://lebrikabrak.free.fr/
 * E-mail   : lebrikabrak@free.fr
 * version 1.6.2
 */
if (stristr($_SERVER["SCRIPT_NAME"], "functions_upload.inc")) {
  header("location:../index.php");
  die();
}

//Fonction pour contrler et corriger le nom d'un rpertoire ou d'un fichier
function cleanName($name,$up=false) {
	$nameClean = trim($name);
	$nameClean = strtr($nameClean, " ", "_aaaaaaaeeeeiiiiooooouuuuync");
	$nameClean = ($up)? preg_replace('`[^-a-z0-9_\.]+`i','',$nameClean) : preg_replace('`[^-a-z0-9_]+`i','',$nameClean);
	$ext = strrchr($nameClean,'.');
	$pos = strrpos($nameClean,'.');
	if($up) $nameClean = substr_replace($nameClean,strtolower($ext),$pos); 

	return $nameClean;
}

//Fonction pour crer un rpertoire accessible  l'upload s'il n'existe pas
function createNewRep($newrep) {
    @mkdir(CHEMIN.$newrep,0755);
	@copy(CHEMIN."data/index.php", CHEMIN.$newrep."/index.php");
	@chmod(CHEMIN.$newrep."/index.php", 0644);
};

//Fonction pour controler la validit des rpertoires accessible  l'upload
function controlNameRepUpload($nameRepUp) {
	$nbRepUp = count($nameRepUp);
	for ($i=0; $i<$nbRepUp; $i++) {
		if($nameRepUp[$i] == '' || !preg_match('`^[-a-z0-9_]+(?:\/[-a-z0-9_]+)*$`i', $nameRepUp[$i]) ) {
			unset($nameRepUp[$i]);
		} else {
			if ($nameRepUp[$i] == "0" ) {$nameRepUp[$i] = "0_";}
			
			$subdirs = explode('/', $nameRepUp[$i]);
			$pathDir = $subdirs[0];
			
			for ($j = 0; $j < count($subdirs); $j ++) { 
				if(!is_dir(CHEMIN.$pathDir) ) {
					createNewRep($pathDir);
				}
				if (isset($subdirs[$j+1])) $pathDir .= '/'.$subdirs[$j+1];
			}
		}
	}

	if(count($nameRepUp) > 0) {
		$nameRepUp = array_values($nameRepUp);
		return $nameRepUp;
	} else {
		return die('Erreur dans la variable $accessRepUpload..Veuillez vrifier qu\'elle n\'est pas vide ou que les noms des rpertoires sont crits correctement.');
	}
}

//Fonction pour controler la validit des rpertoires accessible  l'upload
function controlAccessRepUpload($accessRepUploadType,$accessRepUpload,$type) {
	$nbRepUp = count($accessRepUploadType);
	for ($i=0; $i<$nbRepUp; $i++) {
		if ($accessRepUploadType[$i] == "0" ) {$accessRepUploadType[$i] = "0_";}
		if(!in_array($accessRepUploadType[$i],$accessRepUpload) || $accessRepUploadType[$i] == '' || !preg_match('`^[-a-z0-9_]+(?:\/[-a-z0-9_]+)*$`i', $accessRepUploadType[$i]) ) unset($accessRepUploadType[$i]);
	}
	if(count($accessRepUploadType) > 0) {
		$accessRepUploadType = array_values($accessRepUploadType);
		return $accessRepUploadType;
	} else {
		return die('Erreur dans la variable $accessRepUpload'.$type.'.Veuillez vrifier qu\'elle n\'est pas vide ou que les noms des rpertoires sont crits correctement.');
	}
}

//Fonction qui permet de supprimer des sous-rpertoires
function DelSubRep($sous_dossier) {
	$d = opendir($sous_dossier); 
	while ( false !== ($f = readdir($d)) ) {
        if(is_file($sous_dossier.$f)) {
            @unlink($sous_dossier.$f);
		}	
        if(is_dir($sous_dossier.$f) && $f != '..' && $f != '.') {
		    DelSubRep($sous_dossier.$f.'/');
            @rmdir($sous_dossier.$f);			 
		}
	}
	closedir($d);
}

?>